using System;
using System.IO;
namespace sampa
{
	public class Sampa
	{
		char [] bezdzwieczne={'t', 'p', 'f', 's','k', 'c',  '', '','S','x'};
		//char [] dzwieczne={d, b, w, z, g, dz, , d, j, , r, l, m, n, , , d, a, o, e, i, u, , , y};
		//zwarte,trace	//{b,d,g,dz,dz,dZ,v,z,z,Z }
		
		public Sampa()
		{
		}
		
		public string transcrypt(string str)
		{
			string tamoStr = TamoFun(str);
			
			char [] arr= tamoStr.ToCharArray(); 

			arr = ubezdzwiecznij(arr);
			arr = ubezdzwiecznij2(arr);

			string output = arrToString(arr) ;

			return  output;
		}

		string arrToString(char[] arr)
		{
			string str="";
			int len=arr.Length; 
			for(int i=0;i<len;i++)
			{
				str+=arr[i];
			}	
			return str;
		}

		/*
		 * Od powyszej zasady jest wyjtek, gdy przed liter w lub sekwencj rz 
		 * stoi goska bezdwiczna. Caa sekwencja staje si bezdwiczna. np. kwiat 
		 *  /kfjat/, szwaczka - /SfatSka/
		*/
		char[] ubezdzwiecznij2(char[] arr)
		{
			string output="";
			int len =arr.Length;

			for(int i=0;i<len;i++)
			{
				if(i>1)
				{
					if(arr[i]=='v'  )
					{
						if(isBezdzwieczna(arr[i-2]) )
						{
							output+="f:";
							i++;
						}
                        else if(isszczch(arr[i-2]))
						{
							output+="f:";
							i++;
						}
						else
						{
							output+=arr[i]; 
						}

					}
					else if(arr[i]=='Z')//???? jak rz jest w sampa
					{
						if(isBezdzwieczna(arr[i-2]))
						{
							output+="S:";
							i++;
						
 
						}
						else
						{
							output+=arr[i];
						}
					}
					else
					{
						output+=arr[i];
					}
				}
				else
				{
					output+=arr[i];
				}
				
			}
			return output.ToCharArray();  
		}

		bool isszczch(char c)
		{
			if(c=='S' )//sz
				return true;
			else if(c=='x')//ch
				return true;
			else
				return false;
		}

		void AddDot(String s)
		{
			s+=":";
		}
		
		/*
		Goski zwarte (/b,d,g/), zwarto-trce (/dz,dz,dZ/) i trce (/v,z,z,Z/)
		wymwione przed goskami bezdwicznymi, przerw(w wygosie) staj si 
		bezdwicznymi i ich wymowa jest dokadna, jak ich bezdwicznych odpowiednikw,
		tj. /p,t,k/, /ts,ts,tS/ czy /f,s,s,S/. To samo wystpuje u zbiegu wyrazw
		wymwionych bez przerwy
		*/

		char[] ubezdzwiecznij(char[] arr)
		{	
			String output="";
			int len =arr.Length;
			
			for(int i=0;i<len-1;i++)
			{
				if(i<arr.Length-3)
				{
					if(arr[i]=='d' && arr[i+1]=='z' && arr[i+2]=='\'' && (isBezdzwieczna(arr[i+4])||isBezdzwieczna(arr[i+5]) ))//|| isszczch(arr[i+1],arr[i+2]))) 
					{
						output+="ts\'";
						i+=2;
					
					}
					else if(arr[i]=='d' && arr[i+1]=='z' && (isBezdzwieczna(arr[i+3])||isBezdzwieczna(arr[i+4])) )//|| isszczch(arr[i+1],arr[i+2]) ))
					{
						output+="ts";
						i++;
				
					}
					else if(arr[i]=='d' && arr[i+1]=='Z'  && (isBezdzwieczna(arr[i+3])||isBezdzwieczna(arr[i+4])) )//|| isszczch(arr[i+1],arr[i+2]) ))
					{	
						output+="tS";
						i++;
					
					}
					else if(arr[i]=='z' && arr[i+2]=='\''  && isBezdzwieczna(arr[i+3]) )//|| isszczch(arr[i+1],arr[i+2]) ))
					{	
						output+="s\':";
						i++;
					
					}

					else if(arr[i]=='b' && (isBezdzwieczna(arr[i+2]) ||isBezdzwieczna(arr[i+3]) )) 
						output+="p";
					else if (arr[i]=='d' &&( isBezdzwieczna(arr[i+2]) ||isBezdzwieczna(arr[i+3])) )
						output+="t";
					else if (arr[i]=='g' &&( isBezdzwieczna(arr[i+2]) ||isBezdzwieczna(arr[i+3])) )
						output+="k";
					else if (arr[i]=='v' && (isBezdzwieczna(arr[i+2]) ||isBezdzwieczna(arr[i+3])) )
						output+="f";
					else if (arr[i]=='z' && (isBezdzwieczna(arr[i+2]) ||isBezdzwieczna(arr[i+3])) )
						output+="s";
					else if (arr[i]=='Z' && (isBezdzwieczna(arr[i+2]) ||isBezdzwieczna(arr[i+3])) )
						output+="S";
		
					else

						output+=arr[i]; 
				}//if len>3
				else
				{
					output+=arr[i]; 
				}



			}
			
			
			return output.ToCharArray(); 
		}
		string TamoFun(string str)
		{
			char[] samogloski = {'a', 'i', 'u', 'e', 'o', 'y', '', ''};
			char[] jotujace = { 'p', 'b', 't', 'd', 'k', 'g', 'm', 'l', 'r', 'f', 'w', 'h'};
			char[] numbers = {'1', '2', '3', '4', '5', '6', '7', '8', '9', '0'};

			string[] split = str.Trim().Split(' ');
			string sampa = "";
			bool bracket = false;
			char[] word = null;
			

			for (int j = 0; j < split.Length; j++)
			{
				if( split[j].EndsWith("]") )
				{
					split[j] = split[j].Remove(split[j].Length - 1, 1);
                    bracket = true;
				}

				word = split[j].ToCharArray();

				for (int i = 0; i < word.Length; i++)
				{
					switch (word[i])
					{
						case 'i': 
							if (i != word.Length - 1)
							{
								if (i != 0 && charInArr(word[i+1], samogloski) && charInArr(word[i-1], jotujace))
								{
									sampa += "j";
									sampa += ":";
								}
								else
								{
									sampa += "i";
									sampa += ":";
								}
							}
							else 
							{
								sampa += "i";sampa += ":";
							}
							break;

						case '': 
							if (i != word.Length - 1)
							{
								if( (word[i+1] == 'p') || (word[i+1] == 'b'))
								{
									sampa += "e:m";sampa += ":";
								}
								else if( (word[i+1] == 'k') || (word[i+1] == 'g'))
								{
									sampa += "e:N";sampa += ":";
								}
								else if( (word[i+1] == 'l') || (word[i+1] == ''))
								{
									sampa += "e";sampa += ":";
								}
								else if(word[i+1] == 't')
								{
									sampa += "e:n";sampa += ":";
								}
								else if(word[i+1] == 'c')
								{
									if ( (i != word.Length- 2) && (word[i+2] == 'i') )
										sampa += "e:n':";
									else 
										sampa += "e:n:";
								}
								else if(word[i+1] == '')
								{
									sampa += "e:n':";
								}
								else if(word[i+1] == 'd')
								{
									if (i != word.Length - 2)
									{
										if (word[i+2] == '')
											sampa += "e:n':";
										else if ( (i != word.Length - 3) && (word[i+2] == 'z') && (word[i+3] == 'i'))
											sampa += "e:n':";
										else 
											sampa += "e:n:";									
									}
									else
									{
										sampa += "e:n";sampa += ":";
									}
								}
								else
								{
									sampa += "e:n";sampa += ":";
								}
							}
							else
							{
								sampa += "e~";sampa += ":";
							}
							break;

						case '': 
							if (i != word.Length - 1)
							{
								if( (word[i+1] == 'p') || (word[i+1] == 'b'))
								{
									sampa += "o:m";sampa += ":";
								}
								else if( (word[i+1] == 'k') || (word[i+1] == 'g'))
								{
									sampa += "o:N";sampa += ":";
								}
								else if( (word[i+1] == 'l') || (word[i+1] == ''))
								{
									sampa += "o";sampa += ":";
								}
								else if(word[i+1] == 't')
								{
									sampa += "o:n";sampa += ":";
								}
								else if(word[i+1] == 'c')
								{
									if ( (i != word.Length- 2) && (word[i+2] == 'i') )
										sampa += "o:n':";
									else 
										sampa += "o:n:";
								}
								else if(word[i+1] == '')
								{
									sampa += "o:n':";
								}
								else if(word[i+1] == 'd')
								{
									if (i != word.Length - 2)
									{
										if (word[i+2] == '')
											sampa += "o:n':";
										else if ( (i != word.Length - 3) && (word[i+2] == 'z') && (word[i+3] == 'i'))
											sampa += "o:n':";
										else 
											sampa += "o:n:";									
									}
									else
									{
										sampa += "o:n";sampa += ":";
									}
								}
								else
								{
									sampa += "o:n";sampa += ":";
								}
							}
							else
							{
								sampa += "o~";sampa += ":";
							}
							break;

						case 'n':
							if (i != word.Length - 1)
							{
								if ( (word[i+1] == 'k') || (word[i+1] == 'g') )
								{
									sampa += "N";sampa += ":";
								}
								else if (word[i+1] == 'i')
								{
									if (i+1 == word.Length - 1)
									{
										sampa += "n':i";sampa += ":";
										i++;
									}
									else
									{
										if ( charInArr(word[i+2], samogloski) )
										{
											sampa += "n'";sampa += ":";
											i++;
										}
										else
										{
											sampa += "n':i";sampa += ":";
											i++;
										}
									}
								}
								else
								{
									sampa += "n";sampa += ":";
								}
							}
							else
							{
								sampa += "n";sampa += ":";
							}
							break;

						case 'c':
							if (i != word.Length - 1)
							{
								if (word[i+1] == 'i')
								{
									if (i+1 == word.Length - 1)
									{
										sampa += "ts':i";sampa += ":";
										i++;
									}
									else
									{
										if ( charInArr(word[i+2], samogloski) )
										{
											sampa += "ts'";sampa += ":";
											i++;
										}
										else
										{
											sampa += "ts':i";sampa += ":";
											i++;
										}
									}
								}
								else if (word[i+1] == 'z')
								{
									sampa += "tS";sampa += ":";
									i++;
								}
								else if (word[i+1] == 'h')
								{
									sampa += "x";sampa += ":";
									i++;
								}
								else 
								{
									sampa += "ts";sampa += ":";
								}
							}
							else 
							{
								sampa += "ts";sampa += ":";
							}
							break;

						case 's':
							if (i != word.Length - 1)
							{
								if (word[i+1] == 'i')
								{
									if (i+1 == word.Length - 1)
									{
										sampa += "s':i";sampa += ":";
										i++;
									}
									else
									{
										if ( charInArr(word[i+2], samogloski) )
										{
											sampa += "s'";sampa += ":";
											i++;
										}
										else
										{
											sampa += "s':i";sampa += ":";
											i++;
										}
									}
								}
								else if (word[i+1] == 'z')
								{
									sampa += "S";sampa += ":";
									i++;
								}
								else 
								{
									sampa += "s";sampa += ":";
								}
							}
							else 
							{
								sampa += "s";sampa += ":";
							}
							break;
																	
						case 'z':			
							if (i != word.Length - 1)
							{
								if (word[i+1] == 'i')
								{
									if (i+1 == word.Length - 1)
									{
										sampa += "z':i";sampa += ":";
										i++;
									}
									else
									{
										if ( charInArr(word[i+2], samogloski) )
										{
											sampa += "z'";sampa += ":";
											i++;
										}
										else
										{
											sampa += "z':i";sampa += ":";
											i++;
										}
									}
								}
								else
								{
									sampa += "z";sampa += ":";
								}
							}
							else
							{
								sampa += "z";sampa += ":";
							}
							break;

						case 'r':
							if (i != word.Length - 1)
							{
								if (word[i+1] == 'z')
								{
									sampa += "Z";sampa += ":";
									i++;
								}
								else if (word[i+1] == '.')
								{
									sampa += "r:o:k:";
									i++;
								}
								else 
								{
									sampa += "r";sampa += ":";
								}
							}
							else 
							{
								sampa += "r";sampa += ":";
							}
							break;

						case 'd':
							if (i != word.Length - 1)
							{
								if ( word[i+1] == 'z')
								{
									if (i != word.Length - 2)
									{
										if (word[i+2] == 'i')
										{
											if (i+2 == word.Length - 1)
											{
												sampa += "dz':i";sampa += ":";
												i +=2;
											}
											else
											{
												if ( charInArr(word[i+3], samogloski) )
												{
													sampa += "dz'";sampa += ":";
													i +=2 ;
												}
												else
												{
													sampa += "dz':i";sampa += ":";
													i +=2;
												}
											}
										}
										else
										{
											sampa+="dz:";
											i++;
										}
									}
									else
									{
										sampa+="dz:";
										i++;
									}
								}
								else if (word[i+1] == '')
								{
									sampa+="dZ:";
									i++;
								}
								else if (word[i+1] == '')
								{
									sampa+="dz':";
									i++;
								}
								else
								{
									sampa+="d:";
								}
							}
							else
							{
								sampa+="d:";
							}
							break;
						
						case '0':
							break;
						case '1':
							if (i+3 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers) && charInArr(word[i+3], numbers))
								sampa += "t:I:s':o:n:ts: ";
							else if (i+2 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers))
								sampa += "s:t:o: ";
							else if (i+1 < word.Length && charInArr(word[i+1], numbers))
							{
								if (word[i+1] == '0')
									sampa += "dz':e:s':e:n':ts':";
								else if (word[i+1] == '1')
									sampa += "j:e:d:e:n:a:s':ts':e:";
								else if (word[i+1] == '2')
									sampa += "d:v:a:n:a:s':ts':e:";
								else if (word[i+1] == '3')
									sampa += "t:Z:y:n:a:s':ts':e:";
								else if (word[i+1] == '4')
									sampa += "tS:t:e:r:n:a:s':ts':e:";
								else if (word[i+1] == '5')
									sampa += "p:i:e:t:n:a:s':ts':e:";
								else if (word[i+1] == '6')
									sampa += "s:z:e:s:n:a:s':ts':e:";
								else if (word[i+1] == '7')
									sampa += "s':e:d:e:m:n:a:s':ts':e:";
								else if (word[i+1] == '8')
									sampa += "o:s':e:m:n:a:s':ts':e:";
								else if (word[i+1] == '9')
									sampa += "d:z:i:e:v:i:e:t:n:a:s':ts':e:";
								i++;
							}
							else 
								sampa += "j:e:d:e:n:";
							break;
						case '2':
							if (i+3 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers) && charInArr(word[i+3], numbers))
								sampa += "d:v:a: t:I:s':o:n:ts:e: ";
							else if (i+2 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers))
								sampa += "d:v:i:e:s':ts':e: ";
							else if (i+1 < word.Length && charInArr(word[i+1], numbers))
							{
								sampa += "d:v:a:dz':e:s':ts':a: ";
							}
							else 
								sampa += "d:v:a:";
							break;
						case '3':
							if (i+3 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers) && charInArr(word[i+3], numbers))
								sampa += "t:Z:I: t:I:s':o:n:ts:e: ";
							else if (i+2 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers))
								sampa += "t:Z:I:s:t:a: ";
							else if (i+1 < word.Length && charInArr(word[i+1], numbers))
							{
								sampa += "t:Z:I:dz':e:s':ts':i: ";
							}
							else 
								sampa += "t:Z:I:";
							break;
						case '4':
							if (i+3 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers) && charInArr(word[i+3], numbers))
								sampa += "tS:t:e:r:I: t:I:s':o:n:ts:e: ";
							else if (i+2 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers))
								sampa += "tS:t:e:r:I:s:t:a: ";
							else if (i+1 < word.Length && charInArr(word[i+1], numbers))
							{
								sampa += "tS:t:e:r:dz':e:s':ts':i: ";
							}
							else 
								sampa += "tS:t:e:r:I:";
							break;
						case '5':
							if (i+3 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers) && charInArr(word[i+3], numbers))
								sampa += "p:i:e:n':ts': t:I:s':e:n:ts:I: ";
							else if (i+2 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers))
								sampa += "p:i:e:n':s:e:t: ";
							else if (i+1 < word.Length && charInArr(word[i+1], numbers))
							{
								sampa += "p:i:e:n':dz':e:s':o:n:t: ";
							}
							else 
								sampa += "p:i:e:n':ts':";
							break;
						case '6':
							if (i+3 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers) && charInArr(word[i+3], numbers))
								sampa += "S:e:s':ts': t:I:s':e:n:ts:I: ";
							else if (i+2 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers))
								sampa += "S:e:s':ts':s:e:t: ";
							else if (i+1 < word.Length && charInArr(word[i+1], numbers))
							{
								sampa += "S:e:s':ts':dz':e:s':o:n:t: ";
							}
							else 
								sampa += "S:e:s':ts':";
							break;
						case '7':
							if (i+3 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers) && charInArr(word[i+3], numbers))
								sampa += "s':e:d:e:m: t:I:s':e:n:ts:I: ";
							else if (i+2 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers))
								sampa += "s':e:d:e:m:s:e:t: ";
							else if (i+1 < word.Length && charInArr(word[i+1], numbers))
							{
								sampa += "s':e:d:e:m:dz':e:s':o:n:t: ";
							}
							else 
								sampa += "s':e:d:e:m:";
							break;
						case '8':
							if (i+3 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers) && charInArr(word[i+3], numbers))
								sampa += "o:s':e:m: t:I:s':e:n:ts:I: ";
							else if (i+2 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers))
								sampa += "o:s':e:m:s:e:t: ";
							else if (i+1 < word.Length && charInArr(word[i+1], numbers))
							{
								sampa += "o:s':e:m:dz':e:s':o:n:t: ";
							}
							else 
								sampa += "o:s':e:m:";
							break;
						case '9':
							if (i+3 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers) && charInArr(word[i+3], numbers))
								sampa += "dz':e:v:i:e:n':ts': t:I:s':e:n:ts:I: ";
							else if (i+2 < word.Length && charInArr(word[i+1], numbers) && charInArr(word[i+2], numbers))
								sampa += "dz':e:v:i:e:n':ts':s:e:t: ";
							else if (i+1 < word.Length && charInArr(word[i+1], numbers))
							{
								sampa += "dz':e:v:i:e:n':dz':e:s':o:n:t: ";
							}
							else 
								sampa += "dz':e:v:i:e:n':ts':";
							break;

						case 'h':
							sampa += "x";sampa += ":";
							break;
						case 'y':
							sampa += "I";sampa += ":";
							break;
						case 'w':
							sampa += "v";sampa += ":";
							break;
						case '':
							sampa += "w";sampa += ":";
							break;
						case '':
							sampa += "u";sampa += ":";
							break;
						case '':
							sampa += "n'";sampa += ":";
							break;
						case '':
							sampa += "ts'";sampa += ":";
							break;
						case '':
							sampa += "s'";sampa += ":";
							break;
						case '':
							sampa += "Z";sampa += ":";
							break;
						case '':
							sampa += "z'";sampa += ":";
							break;
						case ',':
							break;
						
						default:
							sampa += word[i];sampa += ":";
							break;
					}
				}
				if(bracket)
				{
					sampa += "]: ";
					bracket = false;
				}
				else
					sampa += " ";
			}
			return sampa;
		}
		
	
		bool charInArr(char cha, char[] arr)
		{
			foreach(char c in arr)
			{
				if (c == cha)
					return true;
			}
			return false;
		}

		bool strInArr(string str, string[] arr)
		{
			foreach(string s in arr)
			{
				if (s.Equals(str))
					return true;
			}
			return false;
		}

		bool isBezdzwieczna(char c)
		{
			int len=bezdzwieczne.Length; 
			for(int i=0;i<len;i++)
			{
				if(c==bezdzwieczne[i])
					return true;
								
			}
			return false;
		}

	}
}